diff a/src/hotspot/share/ci/ciArrayKlass.hpp b/src/hotspot/share/ci/ciArrayKlass.hpp
--- a/src/hotspot/share/ci/ciArrayKlass.hpp
+++ b/src/hotspot/share/ci/ciArrayKlass.hpp
@@ -53,9 +53,17 @@
   bool is_leaf_type();          // No subtypes of this array type.
 
   // What kind of vmObject is this?
   bool is_array_klass() const { return true; }
 
-  static ciArrayKlass* make(ciType* element_type);
+  // The one-level type of the array elements.
+  virtual ciKlass* element_klass() { return nullptr; }
+
+  static ciArrayKlass* make(ciType* klass, bool null_free = false);
+
+  int array_header_in_bytes();
+  ciInstance* component_mirror_instance() const;
+
+  virtual bool is_elem_null_free() const { return false; }
 };
 
 #endif // SHARE_CI_CIARRAYKLASS_HPP
